






Global MAX_RANGE# = 5000.0
Function Render()
	
	LockBuffer GraphicsBuffer()
	
	Local x,y
	For x=0 To SCREENWIDTH-1
		For y=0 To SCREENHEIGHT-1
			
			Local r#=0.0, g#=0.0, b#=0.0
			Local ray.TRay = CreateRay( Float(x), Float(y), -200.0, 0.0, 0.0, 1.0 )
			t=MAX_RANGE
			
			
			Local s.TSphere, currentSphere.TSphere=Null
			For s=Each TSphere
				If HitSphere( s, ray ) Then
					currentSphere = s
				End If
			Next
			
			If currentSphere=Null Then Goto continue1
			
			Local tmpV.TVector = ScalMultN( ray\dir, t# )
			Local intersetion.TVector = AddN( ray\ori, tmpV )
			Delete tmpV
			
			Local n.TVector = SubtN( intersetion, currentSphere\pos )
			Local tmpF#=DotProduct#( n, n )
			If tmpF#=0.0 Then Goto continue2
			
			tmpF#=1.0/(tmpF#^0.5)
			n=ScalMult( n, tmpF# )
			
			
			;Light
			Local l.TLight
			For l=Each TLight
				
				Local dist.TVector = SubtN( l\pos, intersetion )
				If DotProduct( n, dist )<=0.0 Then Goto continuelight ; Test ob das Licht von hinten auf die Kugel trifft
				
				t#=DotProduct#( dist, dist )^0.5 ; Lnge des Vektorsberechnen
				If t#<=0.0 Then Goto continuelight
				
				Local lightray.TRay=New TRay			; Einen Lichtstrahl erstellen
				lightray\ori=intersetion
				lightray\dir=ScalMultN( dist, 1.0/t# )
				
				
				For s=Each TSphere
					If HitSphere( s, lightray ) Then
						Goto continuelight2 ; Lichtstrahl unterbrochen
					End If
				Next
				
				Local lambert#=DotProduct#( lightray\dir, n )
				r#=r# + lambert# * l\colr# * currentSphere\material\r#
				g#=g# + lambert# * l\colg# * currentSphere\material\g#
				b#=b# + lambert# * l\colb# * currentSphere\material\b#
				
				
				.continuelight2
				DeleteRay lightray
				
				.continuelight
				Delete dist
				
			Next
			
			
			
			
			Local rgb=Min#(r#, 255.0)*$10000+Min#(g#, 255.0)*$100+Min#(b#, 255.0)
			WritePixelFast( x,y, rgb, GraphicsBuffer() )
			
			
			.continue2
			Delete n
			Delete intersetion
			
			.continue1
			DeleteRay( ray )
			
			;DebugLog x+"/"+y
			
		Next
	Next
	
	UnlockBuffer GraphicsBuffer()
	
End Function



Type TRay
	Field ori.TVector
	Field dir.TVector
End Type

Function CreateRayV.TRay( ori.TVector, dir.TVector )
	
	Local r.TRay=New TRay
	
	r\ori=ori
	r\dir=dir
	
	Return r
	
End Function

Function CreateRay.TRay( ox#, oy#, oz#, dx#, dy#, dz# )
	
	Local r.TRay=New TRay
	
	r\ori=Vector( ox#, oy#, oz# )
	r\dir=Vector( dx#, dy#, dz# )
	
	Return r
	
End Function

Function DeleteRay( r.TRay )
	
	Delete r\ori
	Delete r\dir
	Delete r
	
End Function




Type TSphere
	Field pos.TVector
	Field radius#
	
	Field material.TMaterial
End Type

Global t#=0.0
Function HitSphere( s.TSphere, r.TRay )
	
	Local dist.TVector=SubtN( s\pos, r\ori )
	Local B#=DotProduct#( r\dir, dist )
	Local D#= B#*B# - DotProduct#( dist, dist ) + s\radius#*s\radius#
	Delete dist
	
	If D#<0.0 Then Return 0
	
	Local t0# = B# - D#^0.5
	Local t1# = B# + D#^0.5
	Local ret=0
	
	If t0# > 0.1 And t0# < t# Then
        t# = t0#
        ret = 1
	End If
	
	If t1# > 0.1 And t1# < t# Then
        t# = t1#
        ret = 1
	End If
	
	Return ret
	
End Function

Function CreateSphere.TSphere( x#, y#, z#, r# )
	Local s.TSphere = New TSphere
	
	s\pos = Vector( x, y, z )
	s\radius = r
	
	s\material = DEFAULT_MATERIAL
	
	Return s
End Function

Function DeleteSphere( s.TSphere )
	Delete s\pos
	Delete s
End Function

Function SetSphereMaterial( s.TSphere, material.TMaterial )
	Delete s\material
	s\material=material
End Function



Type TVector
	Field x#,y#,z#
End Type

Function Vector.TVector( x#, y#, z# )
	Local v.TVector=New TVector
	v\x#=x#
	v\y#=y#
	v\z#=z#
	Return v
End Function

Function SubtN.TVector( v1.TVector, v2.TVector )
	Return Vector( v1\x#-v2\x#, v1\y#-v2\y#, v1\z#-v2\z# )
End Function

Function DotProduct#( v1.TVector, v2.TVector )
	Return v1\x#*v2\x# + v1\y#*v2\y# + v1\z#*v2\z#
End Function

Function AddN.TVector( v1.TVector, v2.TVector )
	Return Vector( v1\x#+v2\x#, v1\y#+v2\y#, v1\z#+v2\z# )
End Function

Function ScalMultN.TVector( v.TVector, x# )
	Return Vector( v\x#*x#, v\y#*x#, v\z#*x# )
End Function

Function ScalMult.TVector( v.TVector, x# )
	v\x#=v\x#*x#
	v\y#=v\y#*x#
	v\z#=v\z#*x#
	Return v
End Function



Type TMaterial
	Field reflection#
	Field r#,g#,b#
End Type

Function CreateMaterial.TMaterial( r#, g#, b#, refl# )
	Local mat.TMaterial=New TMaterial
	mat\r#=r#
	mat\g#=g#
	mat\b#=b#
	mat\reflection#=refl#
	Return mat
End Function

Global DEFAULT_MATERIAL.TMaterial = CreateMaterial( 255.0, 255.0, 255.0, 0 )



Type TLight
	Field pos.TVector
	Field colr#,colg#,colb#
End Type

Function CreateLight.TLight( x#, y#, z# )
	Local l.TLight = New TLight
	l\pos = Vector( x, y, z )
	Return l
End Function

Function SetLightColor( l.TLight, r#, g#, b# )
	l\colr=r
	l\colg=g
	l\colb=b
End Function
	



Function Min#( a#, b# )
	If a<b Then 
		Return a 
	Else
		Return b
	End If
End Function

;~IDEal Editor Parameters:
;~F#66#6B#76#81#8C#94#AF#BA#BF#C6#CA#D2#D6#DA#DE#E2#EB#F0#FD#102
;~F#108#111
;~C#Blitz3D